/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CancelacionCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.CancelacionCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.CancelacionCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("cancelacionCtrlService")
public class CancelacionCtrlServiceImpl implements CancelacionCtrlService {

    @Autowired
    private CancelacionCtrlDAO cancelacionCtrlDAO;

    public List<CancelacionCtrl> obtenerTodos() {
        return cancelacionCtrlDAO.obtenerTodos();
    }

    public CancelacionCtrl obtenerID(Integer id) {
        return cancelacionCtrlDAO.obtenerID(id);
    }

    @Transactional
    public CancelacionCtrl suscribir(CancelacionCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cancelacionCtrlDAO.suscribir(entidad);
    }

    @Transactional
    public CancelacionCtrl actualizacion(CancelacionCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cancelacionCtrlDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CancelacionCtrl entidad) {
        
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        cancelacionCtrlDAO.actualizacion(entidad);
    }

    public List<CancelacionCtrl> buscar(Date tiempoprevsalida, PuntoVenta puntoVenta, Parada paradaOrigem, Parada paradaDestino, Marca marca) {
         return cancelacionCtrlDAO.buscar(tiempoprevsalida,puntoVenta,paradaOrigem,paradaDestino,marca);
    }
}
